Index: /pjproject/trunk/build.symbian/bld.inf
===================================================================
--- /pjproject/trunk/build.symbian/bld.inf	(revision 1423)
+++ /pjproject/trunk/build.symbian/bld.inf	(revision 1424)
@@ -2,9 +2,9 @@
 winscw
 //armv5
-//gcce
+gcce
 
 prj_mmpfiles
 pjlib.mmp
-pjlib_test.mmp
+//pjlib_test.mmp
 pjlib_util.mmp
 pjnath.mmp
Index: /pjproject/trunk/build.symbian/pjsip_simple.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 1423)
+++ /pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 1424)
@@ -42,4 +42,5 @@
 SOURCE	presence_body.c
 SOURCE	publishc.c
+SOURCE	rpid.c
 SOURCE	xpidf.c
 
Index: /pjproject/trunk/build.symbian/pjsip_simpleU.def
===================================================================
--- /pjproject/trunk/build.symbian/pjsip_simpleU.def	(revision 1423)
+++ /pjproject/trunk/build.symbian/pjsip_simpleU.def	(revision 1424)
@@ -29,65 +29,68 @@
 	pjpidf_tuple_set_timestamp               @ 28 NONAME
 	pjpidf_tuple_set_timestamp_np            @ 29 NONAME
-	pjsip_allow_events_hdr_create            @ 30 NONAME
-	pjsip_event_hdr_create                   @ 31 NONAME
-	pjsip_evsub_accept                       @ 32 NONAME
-	pjsip_evsub_create_uac                   @ 33 NONAME
-	pjsip_evsub_create_uas                   @ 34 NONAME
-	pjsip_evsub_current_notify               @ 35 NONAME
-	pjsip_evsub_get_allow_events_hdr         @ 36 NONAME
-	pjsip_evsub_get_mod_data                 @ 37 NONAME
-	pjsip_evsub_get_state                    @ 38 NONAME
-	pjsip_evsub_get_state_name               @ 39 NONAME
-	pjsip_evsub_init_module                  @ 40 NONAME
-	pjsip_evsub_init_parser                  @ 41 NONAME
-	pjsip_evsub_initiate                     @ 42 NONAME
-	pjsip_evsub_instance                     @ 43 NONAME
-	pjsip_evsub_notify                       @ 44 NONAME
-	pjsip_evsub_register_pkg                 @ 45 NONAME
-	pjsip_evsub_send_request                 @ 46 NONAME
-	pjsip_evsub_set_mod_data                 @ 47 NONAME
-	pjsip_evsub_terminate                    @ 48 NONAME
-	pjsip_get_notify_method                  @ 49 NONAME
-	pjsip_get_subscribe_method               @ 50 NONAME
-	pjsip_iscomposing_create_body            @ 51 NONAME
-	pjsip_iscomposing_create_xml             @ 52 NONAME
-	pjsip_iscomposing_parse                  @ 53 NONAME
-	pjsip_notify_method                      @ 54 NONAME
-	pjsip_pres_accept                        @ 55 NONAME
-	pjsip_pres_create_pidf                   @ 56 NONAME
-	pjsip_pres_create_uac                    @ 57 NONAME
-	pjsip_pres_create_uas                    @ 58 NONAME
-	pjsip_pres_create_xpidf                  @ 59 NONAME
-	pjsip_pres_current_notify                @ 60 NONAME
-	pjsip_pres_get_status                    @ 61 NONAME
-	pjsip_pres_init_module                   @ 62 NONAME
-	pjsip_pres_initiate                      @ 63 NONAME
-	pjsip_pres_instance                      @ 64 NONAME
-	pjsip_pres_notify                        @ 65 NONAME
-	pjsip_pres_parse_pidf                    @ 66 NONAME
-	pjsip_pres_parse_xpidf                   @ 67 NONAME
-	pjsip_pres_send_request                  @ 68 NONAME
-	pjsip_pres_set_status                    @ 69 NONAME
-	pjsip_pres_terminate                     @ 70 NONAME
-	pjsip_publishc_create                    @ 71 NONAME
-	pjsip_publishc_destroy                   @ 72 NONAME
-	pjsip_publishc_get_pool                  @ 73 NONAME
-	pjsip_publishc_init                      @ 74 NONAME
-	pjsip_publishc_init_module               @ 75 NONAME
-	pjsip_publishc_publish                   @ 76 NONAME
-	pjsip_publishc_send                      @ 77 NONAME
-	pjsip_publishc_set_credentials           @ 78 NONAME
-	pjsip_publishc_set_route_set             @ 79 NONAME
-	pjsip_publishc_unpublish                 @ 80 NONAME
-	pjsip_publishc_update_expires            @ 81 NONAME
-	pjsip_sub_state_hdr_create               @ 82 NONAME
-	pjsip_subscribe_method                   @ 83 NONAME
-	pjsip_tsx_get_evsub                      @ 84 NONAME
-	pjsipsimple_strerror                     @ 85 NONAME
-	pjxpidf_create                           @ 86 NONAME
-	pjxpidf_get_status                       @ 87 NONAME
-	pjxpidf_get_uri                          @ 88 NONAME
-	pjxpidf_parse                            @ 89 NONAME
-	pjxpidf_print                            @ 90 NONAME
-	pjxpidf_set_status                       @ 91 NONAME
-	pjxpidf_set_uri                          @ 92 NONAME
+	pjrpid_add_element                       @ 30 NONAME
+	pjrpid_element_dup                       @ 31 NONAME
+	pjrpid_get_element                       @ 32 NONAME
+	pjsip_allow_events_hdr_create            @ 33 NONAME
+	pjsip_event_hdr_create                   @ 34 NONAME
+	pjsip_evsub_accept                       @ 35 NONAME
+	pjsip_evsub_create_uac                   @ 36 NONAME
+	pjsip_evsub_create_uas                   @ 37 NONAME
+	pjsip_evsub_current_notify               @ 38 NONAME
+	pjsip_evsub_get_allow_events_hdr         @ 39 NONAME
+	pjsip_evsub_get_mod_data                 @ 40 NONAME
+	pjsip_evsub_get_state                    @ 41 NONAME
+	pjsip_evsub_get_state_name               @ 42 NONAME
+	pjsip_evsub_init_module                  @ 43 NONAME
+	pjsip_evsub_init_parser                  @ 44 NONAME
+	pjsip_evsub_initiate                     @ 45 NONAME
+	pjsip_evsub_instance                     @ 46 NONAME
+	pjsip_evsub_notify                       @ 47 NONAME
+	pjsip_evsub_register_pkg                 @ 48 NONAME
+	pjsip_evsub_send_request                 @ 49 NONAME
+	pjsip_evsub_set_mod_data                 @ 50 NONAME
+	pjsip_evsub_terminate                    @ 51 NONAME
+	pjsip_get_notify_method                  @ 52 NONAME
+	pjsip_get_subscribe_method               @ 53 NONAME
+	pjsip_iscomposing_create_body            @ 54 NONAME
+	pjsip_iscomposing_create_xml             @ 55 NONAME
+	pjsip_iscomposing_parse                  @ 56 NONAME
+	pjsip_notify_method                      @ 57 NONAME
+	pjsip_pres_accept                        @ 58 NONAME
+	pjsip_pres_create_pidf                   @ 59 NONAME
+	pjsip_pres_create_uac                    @ 60 NONAME
+	pjsip_pres_create_uas                    @ 61 NONAME
+	pjsip_pres_create_xpidf                  @ 62 NONAME
+	pjsip_pres_current_notify                @ 63 NONAME
+	pjsip_pres_get_status                    @ 64 NONAME
+	pjsip_pres_init_module                   @ 65 NONAME
+	pjsip_pres_initiate                      @ 66 NONAME
+	pjsip_pres_instance                      @ 67 NONAME
+	pjsip_pres_notify                        @ 68 NONAME
+	pjsip_pres_parse_pidf                    @ 69 NONAME
+	pjsip_pres_parse_xpidf                   @ 70 NONAME
+	pjsip_pres_send_request                  @ 71 NONAME
+	pjsip_pres_set_status                    @ 72 NONAME
+	pjsip_pres_terminate                     @ 73 NONAME
+	pjsip_publishc_create                    @ 74 NONAME
+	pjsip_publishc_destroy                   @ 75 NONAME
+	pjsip_publishc_get_pool                  @ 76 NONAME
+	pjsip_publishc_init                      @ 77 NONAME
+	pjsip_publishc_init_module               @ 78 NONAME
+	pjsip_publishc_publish                   @ 79 NONAME
+	pjsip_publishc_send                      @ 80 NONAME
+	pjsip_publishc_set_credentials           @ 81 NONAME
+	pjsip_publishc_set_route_set             @ 82 NONAME
+	pjsip_publishc_unpublish                 @ 83 NONAME
+	pjsip_publishc_update_expires            @ 84 NONAME
+	pjsip_sub_state_hdr_create               @ 85 NONAME
+	pjsip_subscribe_method                   @ 86 NONAME
+	pjsip_tsx_get_evsub                      @ 87 NONAME
+	pjsipsimple_strerror                     @ 88 NONAME
+	pjxpidf_create                           @ 89 NONAME
+	pjxpidf_get_status                       @ 90 NONAME
+	pjxpidf_get_uri                          @ 91 NONAME
+	pjxpidf_parse                            @ 92 NONAME
+	pjxpidf_print                            @ 93 NONAME
+	pjxpidf_set_status                       @ 94 NONAME
+	pjxpidf_set_uri                          @ 95 NONAME
Index: /pjproject/trunk/build.symbian/pjsua_libU.def
===================================================================
--- /pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1423)
+++ /pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1424)
@@ -18,97 +18,98 @@
 	pjsua_acc_set_default                    @ 17 NONAME
 	pjsua_acc_set_online_status              @ 18 NONAME
-	pjsua_acc_set_registration               @ 19 NONAME
-	pjsua_acc_set_transport                  @ 20 NONAME
-	pjsua_buddy_add                          @ 21 NONAME
-	pjsua_buddy_config_default               @ 22 NONAME
-	pjsua_buddy_del                          @ 23 NONAME
-	pjsua_buddy_get_info                     @ 24 NONAME
-	pjsua_buddy_is_valid                     @ 25 NONAME
-	pjsua_buddy_subscribe_pres               @ 26 NONAME
-	pjsua_call_answer                        @ 27 NONAME
-	pjsua_call_dial_dtmf                     @ 28 NONAME
-	pjsua_call_dump                          @ 29 NONAME
-	pjsua_call_get_conf_port                 @ 30 NONAME
-	pjsua_call_get_count                     @ 31 NONAME
-	pjsua_call_get_info                      @ 32 NONAME
-	pjsua_call_get_max_count                 @ 33 NONAME
-	pjsua_call_get_user_data                 @ 34 NONAME
-	pjsua_call_hangup                        @ 35 NONAME
-	pjsua_call_hangup_all                    @ 36 NONAME
-	pjsua_call_has_media                     @ 37 NONAME
-	pjsua_call_is_active                     @ 38 NONAME
-	pjsua_call_make_call                     @ 39 NONAME
-	pjsua_call_reinvite                      @ 40 NONAME
-	pjsua_call_send_im                       @ 41 NONAME
-	pjsua_call_send_typing_ind               @ 42 NONAME
-	pjsua_call_set_hold                      @ 43 NONAME
-	pjsua_call_set_user_data                 @ 44 NONAME
-	pjsua_call_xfer                          @ 45 NONAME
-	pjsua_call_xfer_replaces                 @ 46 NONAME
-	pjsua_codec_get_param                    @ 47 NONAME
-	pjsua_codec_set_param                    @ 48 NONAME
-	pjsua_codec_set_priority                 @ 49 NONAME
-	pjsua_conf_add_port                      @ 50 NONAME
-	pjsua_conf_adjust_rx_level               @ 51 NONAME
-	pjsua_conf_adjust_tx_level               @ 52 NONAME
-	pjsua_conf_connect                       @ 53 NONAME
-	pjsua_conf_disconnect                    @ 54 NONAME
-	pjsua_conf_get_active_ports              @ 55 NONAME
-	pjsua_conf_get_max_ports                 @ 56 NONAME
-	pjsua_conf_get_port_info                 @ 57 NONAME
-	pjsua_conf_get_signal_level              @ 58 NONAME
-	pjsua_conf_remove_port                   @ 59 NONAME
-	pjsua_config_default                     @ 60 NONAME
-	pjsua_config_dup                         @ 61 NONAME
-	pjsua_create                             @ 62 NONAME
-	pjsua_destroy                            @ 63 NONAME
-	pjsua_dump                               @ 64 NONAME
-	pjsua_enum_accs                          @ 65 NONAME
-	pjsua_enum_buddies                       @ 66 NONAME
-	pjsua_enum_calls                         @ 67 NONAME
-	pjsua_enum_codecs                        @ 68 NONAME
-	pjsua_enum_conf_ports                    @ 69 NONAME
-	pjsua_enum_snd_devs                      @ 70 NONAME
-	pjsua_enum_transports                    @ 71 NONAME
-	pjsua_get_buddy_count                    @ 72 NONAME
-	pjsua_get_ec_tail                        @ 73 NONAME
-	pjsua_get_pjmedia_endpt                  @ 74 NONAME
-	pjsua_get_pjsip_endpt                    @ 75 NONAME
-	pjsua_get_pool_factory                   @ 76 NONAME
-	pjsua_get_snd_dev                        @ 77 NONAME
-	pjsua_handle_events                      @ 78 NONAME
-	pjsua_im_send                            @ 79 NONAME
-	pjsua_im_typing                          @ 80 NONAME
-	pjsua_init                               @ 81 NONAME
-	pjsua_logging_config_default             @ 82 NONAME
-	pjsua_logging_config_dup                 @ 83 NONAME
-	pjsua_media_config_default               @ 84 NONAME
-	pjsua_media_transports_create            @ 85 NONAME
-	pjsua_msg_data_init                      @ 86 NONAME
-	pjsua_perror                             @ 87 NONAME
-	pjsua_player_create                      @ 88 NONAME
-	pjsua_player_destroy                     @ 89 NONAME
-	pjsua_player_get_conf_port               @ 90 NONAME
-	pjsua_player_get_port                    @ 91 NONAME
-	pjsua_player_set_pos                     @ 92 NONAME
-	pjsua_playlist_create                    @ 93 NONAME
-	pjsua_pool_create                        @ 94 NONAME
-	pjsua_pres_dump                          @ 95 NONAME
-	pjsua_reconfigure_logging                @ 96 NONAME
-	pjsua_recorder_create                    @ 97 NONAME
-	pjsua_recorder_destroy                   @ 98 NONAME
-	pjsua_recorder_get_conf_port             @ 99 NONAME
-	pjsua_recorder_get_port                  @ 100 NONAME
-	pjsua_set_ec                             @ 101 NONAME
-	pjsua_set_no_snd_dev                     @ 102 NONAME
-	pjsua_set_null_snd_dev                   @ 103 NONAME
-	pjsua_set_snd_dev                        @ 104 NONAME
-	pjsua_start                              @ 105 NONAME
-	pjsua_transport_close                    @ 106 NONAME
-	pjsua_transport_config_default           @ 107 NONAME
-	pjsua_transport_config_dup               @ 108 NONAME
-	pjsua_transport_create                   @ 109 NONAME
-	pjsua_transport_get_info                 @ 110 NONAME
-	pjsua_transport_register                 @ 111 NONAME
-	pjsua_transport_set_enable               @ 112 NONAME
-	pjsua_verify_sip_url                     @ 113 NONAME
+	pjsua_acc_set_online_status2             @ 19 NONAME
+	pjsua_acc_set_registration               @ 20 NONAME
+	pjsua_acc_set_transport                  @ 21 NONAME
+	pjsua_buddy_add                          @ 22 NONAME
+	pjsua_buddy_config_default               @ 23 NONAME
+	pjsua_buddy_del                          @ 24 NONAME
+	pjsua_buddy_get_info                     @ 25 NONAME
+	pjsua_buddy_is_valid                     @ 26 NONAME
+	pjsua_buddy_subscribe_pres               @ 27 NONAME
+	pjsua_call_answer                        @ 28 NONAME
+	pjsua_call_dial_dtmf                     @ 29 NONAME
+	pjsua_call_dump                          @ 30 NONAME
+	pjsua_call_get_conf_port                 @ 31 NONAME
+	pjsua_call_get_count                     @ 32 NONAME
+	pjsua_call_get_info                      @ 33 NONAME
+	pjsua_call_get_max_count                 @ 34 NONAME
+	pjsua_call_get_user_data                 @ 35 NONAME
+	pjsua_call_hangup                        @ 36 NONAME
+	pjsua_call_hangup_all                    @ 37 NONAME
+	pjsua_call_has_media                     @ 38 NONAME
+	pjsua_call_is_active                     @ 39 NONAME
+	pjsua_call_make_call                     @ 40 NONAME
+	pjsua_call_reinvite                      @ 41 NONAME
+	pjsua_call_send_im                       @ 42 NONAME
+	pjsua_call_send_typing_ind               @ 43 NONAME
+	pjsua_call_set_hold                      @ 44 NONAME
+	pjsua_call_set_user_data                 @ 45 NONAME
+	pjsua_call_xfer                          @ 46 NONAME
+	pjsua_call_xfer_replaces                 @ 47 NONAME
+	pjsua_codec_get_param                    @ 48 NONAME
+	pjsua_codec_set_param                    @ 49 NONAME
+	pjsua_codec_set_priority                 @ 50 NONAME
+	pjsua_conf_add_port                      @ 51 NONAME
+	pjsua_conf_adjust_rx_level               @ 52 NONAME
+	pjsua_conf_adjust_tx_level               @ 53 NONAME
+	pjsua_conf_connect                       @ 54 NONAME
+	pjsua_conf_disconnect                    @ 55 NONAME
+	pjsua_conf_get_active_ports              @ 56 NONAME
+	pjsua_conf_get_max_ports                 @ 57 NONAME
+	pjsua_conf_get_port_info                 @ 58 NONAME
+	pjsua_conf_get_signal_level              @ 59 NONAME
+	pjsua_conf_remove_port                   @ 60 NONAME
+	pjsua_config_default                     @ 61 NONAME
+	pjsua_config_dup                         @ 62 NONAME
+	pjsua_create                             @ 63 NONAME
+	pjsua_destroy                            @ 64 NONAME
+	pjsua_dump                               @ 65 NONAME
+	pjsua_enum_accs                          @ 66 NONAME
+	pjsua_enum_buddies                       @ 67 NONAME
+	pjsua_enum_calls                         @ 68 NONAME
+	pjsua_enum_codecs                        @ 69 NONAME
+	pjsua_enum_conf_ports                    @ 70 NONAME
+	pjsua_enum_snd_devs                      @ 71 NONAME
+	pjsua_enum_transports                    @ 72 NONAME
+	pjsua_get_buddy_count                    @ 73 NONAME
+	pjsua_get_ec_tail                        @ 74 NONAME
+	pjsua_get_pjmedia_endpt                  @ 75 NONAME
+	pjsua_get_pjsip_endpt                    @ 76 NONAME
+	pjsua_get_pool_factory                   @ 77 NONAME
+	pjsua_get_snd_dev                        @ 78 NONAME
+	pjsua_handle_events                      @ 79 NONAME
+	pjsua_im_send                            @ 80 NONAME
+	pjsua_im_typing                          @ 81 NONAME
+	pjsua_init                               @ 82 NONAME
+	pjsua_logging_config_default             @ 83 NONAME
+	pjsua_logging_config_dup                 @ 84 NONAME
+	pjsua_media_config_default               @ 85 NONAME
+	pjsua_media_transports_create            @ 86 NONAME
+	pjsua_msg_data_init                      @ 87 NONAME
+	pjsua_perror                             @ 88 NONAME
+	pjsua_player_create                      @ 89 NONAME
+	pjsua_player_destroy                     @ 90 NONAME
+	pjsua_player_get_conf_port               @ 91 NONAME
+	pjsua_player_get_port                    @ 92 NONAME
+	pjsua_player_set_pos                     @ 93 NONAME
+	pjsua_playlist_create                    @ 94 NONAME
+	pjsua_pool_create                        @ 95 NONAME
+	pjsua_pres_dump                          @ 96 NONAME
+	pjsua_reconfigure_logging                @ 97 NONAME
+	pjsua_recorder_create                    @ 98 NONAME
+	pjsua_recorder_destroy                   @ 99 NONAME
+	pjsua_recorder_get_conf_port             @ 100 NONAME
+	pjsua_recorder_get_port                  @ 101 NONAME
+	pjsua_set_ec                             @ 102 NONAME
+	pjsua_set_no_snd_dev                     @ 103 NONAME
+	pjsua_set_null_snd_dev                   @ 104 NONAME
+	pjsua_set_snd_dev                        @ 105 NONAME
+	pjsua_start                              @ 106 NONAME
+	pjsua_transport_close                    @ 107 NONAME
+	pjsua_transport_config_default           @ 108 NONAME
+	pjsua_transport_config_dup               @ 109 NONAME
+	pjsua_transport_create                   @ 110 NONAME
+	pjsua_transport_get_info                 @ 111 NONAME
+	pjsua_transport_register                 @ 112 NONAME
+	pjsua_transport_set_enable               @ 113 NONAME
+	pjsua_verify_sip_url                     @ 114 NONAME
Index: /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 1423)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 1424)
@@ -1821,6 +1821,8 @@
 		continue;
 
-	    printf(" [%2d] <%7s>  %.*s\n", 
-		    ids[i]+1, info.status_text.ptr, 
+	    printf(" [%2d] <%.*s>  %.*s\n", 
+		    ids[i]+1, 
+		    (int)info.status_text.slen,
+		    info.status_text.ptr, 
 		    (int)info.uri.slen,
 		    info.uri.ptr);
@@ -1858,6 +1860,7 @@
     printf(" %c[%2d] %.*s: %s\n", (acc_id==current_acc?'*':' '),
 	   acc_id,  (int)info.acc_uri.slen, info.acc_uri.ptr, buf);
-    printf("       Online status: %s\n", 
-	   (info.online_status ? "Online" : "Invisible"));
+    printf("       Online status: %.*s\n", 
+	(int)info.online_status_text.slen,
+	info.online_status_text.ptr);
 }
 
@@ -1888,9 +1891,9 @@
     puts("|  m  Make new call            | +b  Add new buddy       .| +a  Add new accnt |");
     puts("|  M  Make multiple calls      | -b  Delete buddy         | -a  Delete accnt. |");
-    puts("|  a  Answer call              | !b  Modify buddy         | !a  Modify accnt. |");
-    puts("|  h  Hangup call  (ha=all)    |  i  Send IM              | rr  (Re-)register |");
-    puts("|  H  Hold call                |  s  Subscribe presence   | ru  Unregister    |");
-    puts("|  v  re-inVite (release hold) |  u  Unsubscribe presence |  >  Cycle next ac.|");
-    puts("|  ]  Select next dialog       |  t  ToGgle Online status |  <  Cycle prev ac.|");
+    puts("|  a  Answer call              |  i  Send IM              | !a  Modify accnt. |");
+    puts("|  h  Hangup call  (ha=all)    |  s  Subscribe presence   | rr  (Re-)register |");
+    puts("|  H  Hold call                |  u  Unsubscribe presence | ru  Unregister    |");
+    puts("|  v  re-inVite (release hold) |  t  ToGgle Online status |  >  Cycle next ac.|");
+    puts("|  ]  Select next dialog       |  T  Set online status    |  <  Cycle prev ac.|");
     puts("|  [  Select previous dialog   +--------------------------+-------------------+");
     puts("|  x  Xfer call                |      Media Commands:     |  Status & Config: |");
@@ -2089,4 +2092,83 @@
 	return;
     }
+}
+
+
+/*
+ * Change extended online status.
+ */
+static void change_online_status(void)
+{
+    char menuin[32];
+    pj_bool_t online_status;
+    pjrpid_element elem;
+    int i, choice;
+
+    enum {
+	AVAILABLE, BUSY, OTP, IDLE, AWAY, BRB, OFFLINE, OPT_MAX
+    };
+
+    struct opt {
+	int id;
+	char *name;
+    } opts[] = {
+	{ AVAILABLE, "Available" },
+	{ BUSY, "Busy"},
+	{ OTP, "On the phone"},
+	{ IDLE, "Idle"},
+	{ AWAY, "Away"},
+	{ BRB, "Be right back"},
+	{ OFFLINE, "Offline"}
+    };
+
+    printf("\n"
+	   "Choices:\n");
+    for (i=0; i<PJ_ARRAY_SIZE(opts); ++i) {
+	printf("  %d  %s\n", opts[i].id+1, opts[i].name);
+    }
+
+    if (!simple_input("Select status", menuin, sizeof(menuin)))
+	return;
+
+    choice = atoi(menuin) - 1;
+    if (choice < 0 || choice >= OPT_MAX) {
+	puts("Invalid selection");
+	return;
+    }
+
+    pj_bzero(&elem, sizeof(elem));
+    elem.type = PJRPID_ELEMENT_TYPE_PERSON;
+
+    online_status = PJ_TRUE;
+
+    switch (choice) {
+    case AVAILABLE:
+	break;
+    case BUSY:
+	elem.activity = PJRPID_ACTIVITY_BUSY;
+	elem.note = pj_str("Busy");
+	break;
+    case OTP:
+	elem.activity = PJRPID_ACTIVITY_BUSY;
+	elem.note = pj_str("On the phone");
+	break;
+    case IDLE:
+	elem.activity = PJRPID_ACTIVITY_UNKNOWN;
+	elem.note = pj_str("Idle");
+	break;
+    case AWAY:
+	elem.activity = PJRPID_ACTIVITY_AWAY;
+	elem.note = pj_str("Away");
+	break;
+    case BRB:
+	elem.activity = PJRPID_ACTIVITY_UNKNOWN;
+	elem.note = pj_str("Be right back");
+	break;
+    case OFFLINE:
+	online_status = PJ_FALSE;
+	break;
+    }
+
+    pjsua_acc_set_online_status2(current_acc, online_status, &elem);
 }
 
@@ -2803,4 +2885,8 @@
 	    break;
 
+	case 'T':
+	    change_online_status();
+	    break;
+
 	case 'c':
 	    switch (menuin[1]) {
Index: /pjproject/trunk/pjsip/build/Makefile
===================================================================
--- /pjproject/trunk/pjsip/build/Makefile	(revision 1423)
+++ /pjproject/trunk/pjsip/build/Makefile	(revision 1424)
@@ -63,5 +63,5 @@
 			errno.o evsub.o evsub_msg.o iscomposing.o \
 			pidf.o presence.o presence_body.o publishc.o \
-			xpidf.o
+			rpid.o xpidf.o
 export PJSIP_SIMPLE_CFLAGS += $(_CFLAGS)
 
Index: /pjproject/trunk/pjsip/build/pjsip_simple.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_simple.dsp	(revision 1423)
+++ /pjproject/trunk/pjsip/build/pjsip_simple.dsp	(revision 1424)
@@ -41,4 +41,5 @@
 # PROP Intermediate_Dir "./output/pjsip-simple-i386-win32-vc6-release"
 # PROP Target_Dir ""
+F90=df.exe
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
 # ADD CPP /nologo /MD /W4 /GX /Zi /O2 /I "../include" /I "../../pjlib-util/include" /I "../../pjlib/include" /D "NDEBUG" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "WIN32" /D "_MBCS" /D "_LIB" /YX /FD /c
@@ -64,4 +65,5 @@
 # PROP Intermediate_Dir "./output/pjsip-simple-i386-win32-vc6-debug"
 # PROP Target_Dir ""
+F90=df.exe
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
 # ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib-util/include" /I "../../pjlib/include" /D "_DEBUG" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "WIN32" /D "_MBCS" /D "_LIB" /FR /YX /FD /GZ /c
@@ -118,4 +120,8 @@
 # Begin Source File
 
+SOURCE="..\src\pjsip-simple\rpid.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\pjsip-simple\xpidf.c"
 # End Source File
@@ -158,4 +164,8 @@
 # Begin Source File
 
+SOURCE="..\include\pjsip-simple\rpid.h"
+# End Source File
+# Begin Source File
+
 SOURCE="..\include\pjsip-simple\types.h"
 # End Source File
Index: /pjproject/trunk/pjsip/build/pjsip_simple.vcproj
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_simple.vcproj	(revision 1423)
+++ /pjproject/trunk/pjsip/build/pjsip_simple.vcproj	(revision 1424)
@@ -351,4 +351,8 @@
 			</File>
 			<File
+				RelativePath="..\src\pjsip-simple\rpid.c"
+				>
+			</File>
+			<File
 				RelativePath="..\src\pjsip-simple\xpidf.c"
 				>
@@ -410,4 +414,8 @@
 			</File>
 			<File
+				RelativePath="..\include\pjsip-simple\rpid.h"
+				>
+			</File>
+			<File
 				RelativePath="..\include\pjsip-simple\types.h"
 				>
